package ndk.assignment.backup;

interface IBackupService {
	// Archives only exist in the top level of the directory set by the application (or a hardcoded one)
	// and the archive names given as a String cannot contain multiple elements in the path.
	// All the functions must return null or false in case of error (wrong path or exceptions).

	// Returns the name of the archives in the directory currently used for storage
	// Returns null in case the directory does not have any archives or it cannot be accessed
	String[] archives();

	// Returns the complete path of the files in the archive given as a parameter
	// Returns null if the archive does not exist or the path is incorrect (multiple elements)
	// E.g. { "file1", "file2", "dir1/file3", "dir1/dir2/file4" }
	String[] filesInArchive(String archive);

	// Archives the folder or file given by path and returns the name of the archive it created
	// Returns null if it fails
	String archive(String path);

	// Unarchives the archive to the folder given by path
	// Returns true if it succeeds, false otherwise
	boolean unarchive(String archive, String path);
}
